---
title: Seats
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Seats
---

# Seats

The seats API allows you to view, assign, and unassign seats for your organization.

## Get users with seats{% #get-users-with-seats %}

{% tab title="v2" %}

| Datadog site      | API endpoint                                         |
| ----------------- | ---------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v2/seats/users |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v2/seats/users |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v2/seats/users      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v2/seats/users      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v2/seats/users  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v2/seats/users     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v2/seats/users |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v2/seats/users |

### Overview

Get the list of users assigned seats for a product code. This endpoint requires any of the following permissions:
`billing_read``incident_read``on_call_read` 


### Arguments

#### Query Strings

| Name                           | Type    | Description                                        |
| ------------------------------ | ------- | -------------------------------------------------- |
| product_code [*required*] | string  | The product code for which to retrieve seat users. |
| page[limit]                    | integer | Maximum number of results to return.               |
| page[cursor]                   | string  | Cursor for pagination.                             |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
A paginated list of seat user resources with associated pagination metadata.

| Parent field | Field       | Type      | Description                                                 |
| ------------ | ----------- | --------- | ----------------------------------------------------------- |
|              | data        | [object]  | The list of seat users.                                     |
| data         | attributes  | object    | The attributes of the seat user.                            |
| attributes   | assigned_at | date-time | The date and time the seat was assigned.                    |
| attributes   | email       | string    | The email of the user.                                      |
| attributes   | name        | string    | The name of the user.                                       |
| data         | id          | string    | The ID of the seat user.                                    |
| data         | type        | enum      | Seat users resource type. Allowed enum values: `seat-users` |
|              | meta        | object    | The metadata of the seat users.                             |
| meta         | cursor      | string    | The cursor for the seat users.                              |
| meta         | limit       | int64     | The limit for the seat users.                               |
| meta         | next_cursor | string    | The next cursor for the seat users.                         |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": [
    {
      "attributes": {
        "assigned_at": "2021-01-01T00:00:00Z",
        "email": "user@example.com",
        "name": "John Doe"
      },
      "id": "00000000-0000-0000-0000-000000000000",
      "type": "seat-users"
    }
  ],
  "meta": {
    "cursor": "string",
    "limit": "integer",
    "next_cursor": "string"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="422" %}
Unprocessable Entity
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Required query arguments export product_code="CHANGE_ME" \# Curl command curl -X GET "https://api.datadoghq.com/api/v2/seats/users?product_code=${product_code}" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
##### 

```python
"""
Get users with seats returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.seats_api import SeatsApi

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = SeatsApi(api_client)
    response = api_instance.get_seats_users(
        product_code="incident_response",
        page_limit=100,
    )

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Get users with seats returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::SeatsAPI.new
opts = {
  page_limit: 100,
}
p api_instance.get_seats_users("incident_response", opts)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// Get users with seats returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewSeatsApi(apiClient)
	resp, r, err := api.GetSeatsUsers(ctx, "incident_response", *datadogV2.NewGetSeatsUsersOptionalParameters().WithPageLimit(100))

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `SeatsApi.GetSeatsUsers`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `SeatsApi.GetSeatsUsers`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Get users with seats returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.SeatsApi;
import com.datadog.api.client.v2.api.SeatsApi.GetSeatsUsersOptionalParameters;
import com.datadog.api.client.v2.model.SeatUserDataArray;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    SeatsApi apiInstance = new SeatsApi(defaultClient);

    try {
      SeatUserDataArray result =
          apiInstance.getSeatsUsers(
              "incident_response", new GetSeatsUsersOptionalParameters().pageLimit(100));
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SeatsApi#getSeatsUsers");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// Get users with seats returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_seats::GetSeatsUsersOptionalParams;
use datadog_api_client::datadogV2::api_seats::SeatsAPI;

#[tokio::main]
async fn main() {
    let configuration = datadog::Configuration::new();
    let api = SeatsAPI::with_config(configuration);
    let resp = api
        .get_seats_users(
            "incident_response".to_string(),
            GetSeatsUsersOptionalParams::default().page_limit(100),
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Get users with seats returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.SeatsApi(configuration);

const params: v2.SeatsApiGetSeatsUsersRequest = {
  productCode: "incident_response",
  pageLimit: 100,
};

apiInstance
  .getSeatsUsers(params)
  .then((data: v2.SeatUserDataArray) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}

## Assign seats to users{% #assign-seats-to-users %}

{% tab title="v2" %}

| Datadog site      | API endpoint                                          |
| ----------------- | ----------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/seats/users |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/seats/users |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/seats/users      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/seats/users      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/seats/users  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/seats/users     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/seats/users |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/seats/users |

### Overview

Assign seats to users for a product code. This endpoint requires any of the following permissions:
`billing_edit``incident_write``on_call_write` 


### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                          | Type     | Description                                                                        |
| ------------ | ------------------------------ | -------- | ---------------------------------------------------------------------------------- |
|              | data                           | object   | The data for the assign seats user request.                                        |
| data         | attributes [*required*]   | object   | The attributes of the assign seats user request.                                   |
| attributes   | product_code [*required*] | string   | The product code for which to assign seats.                                        |
| attributes   | user_uuids [*required*]   | [string] | The list of user IDs to assign seats to.                                           |
| data         | id                             | string   | The ID of the assign seats user request.                                           |
| data         | type [*required*]         | enum     | The type of the assign seats user request. Allowed enum values: `seat-assignments` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "product_code": "",
      "user_uuids": [
        ""
      ]
    },
    "id": "string",
    "type": "seat-assignments"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
The response body returned after successfully assigning seats to users.

| Parent field | Field        | Type     | Description                                                             |
| ------------ | ------------ | -------- | ----------------------------------------------------------------------- |
|              | data         | object   | The data for the assign seats user response.                            |
| data         | attributes   | object   | The attributes of the assign seats user response.                       |
| attributes   | assigned_ids | [string] | The list of user IDs to which the seats were assigned.                  |
| attributes   | product_code | string   | The product code for which the seats were assigned.                     |
| data         | id           | string   | The ID of the assign seats user response.                               |
| data         | type         | enum     | Seat assignments resource type. Allowed enum values: `seat-assignments` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "assigned_ids": [],
      "product_code": "string"
    },
    "id": "string",
    "type": "seat-assignments"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="422" %}
Unprocessable Entity
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/seats/users" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "product_code": "",
      "user_uuids": [
        ""
      ]
    },
    "type": "seat-assignments"
  }
}
EOF 
                
##### 

```python
"""
Assign seats to users returns "Created" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.seats_api import SeatsApi
from datadog_api_client.v2.model.assign_seats_user_request import AssignSeatsUserRequest
from datadog_api_client.v2.model.assign_seats_user_request_data import AssignSeatsUserRequestData
from datadog_api_client.v2.model.assign_seats_user_request_data_attributes import AssignSeatsUserRequestDataAttributes
from datadog_api_client.v2.model.seat_assignments_data_type import SeatAssignmentsDataType

# there is a valid "user" in the system
USER_DATA_ID = environ["USER_DATA_ID"]

body = AssignSeatsUserRequest(
    data=AssignSeatsUserRequestData(
        type=SeatAssignmentsDataType.SEAT_ASSIGNMENTS,
        attributes=AssignSeatsUserRequestDataAttributes(
            product_code="incident_response",
            user_uuids=[
                USER_DATA_ID,
            ],
        ),
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = SeatsApi(api_client)
    response = api_instance.assign_seats_user(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Assign seats to users returns "Created" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::SeatsAPI.new

# there is a valid "user" in the system
USER_DATA_ID = ENV["USER_DATA_ID"]

body = DatadogAPIClient::V2::AssignSeatsUserRequest.new({
  data: DatadogAPIClient::V2::AssignSeatsUserRequestData.new({
    type: DatadogAPIClient::V2::SeatAssignmentsDataType::SEAT_ASSIGNMENTS,
    attributes: DatadogAPIClient::V2::AssignSeatsUserRequestDataAttributes.new({
      product_code: "incident_response",
      user_uuids: [
        USER_DATA_ID,
      ],
    }),
  }),
})
p api_instance.assign_seats_user(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// Assign seats to users returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	// there is a valid "user" in the system
	UserDataID := os.Getenv("USER_DATA_ID")

	body := datadogV2.AssignSeatsUserRequest{
		Data: &datadogV2.AssignSeatsUserRequestData{
			Type: datadogV2.SEATASSIGNMENTSDATATYPE_SEAT_ASSIGNMENTS,
			Attributes: datadogV2.AssignSeatsUserRequestDataAttributes{
				ProductCode: "incident_response",
				UserUuids: []string{
					UserDataID,
				},
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewSeatsApi(apiClient)
	resp, r, err := api.AssignSeatsUser(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `SeatsApi.AssignSeatsUser`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `SeatsApi.AssignSeatsUser`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Assign seats to users returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.SeatsApi;
import com.datadog.api.client.v2.model.AssignSeatsUserRequest;
import com.datadog.api.client.v2.model.AssignSeatsUserRequestData;
import com.datadog.api.client.v2.model.AssignSeatsUserRequestDataAttributes;
import com.datadog.api.client.v2.model.AssignSeatsUserResponse;
import com.datadog.api.client.v2.model.SeatAssignmentsDataType;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    SeatsApi apiInstance = new SeatsApi(defaultClient);

    // there is a valid "user" in the system
    String USER_DATA_ID = System.getenv("USER_DATA_ID");

    AssignSeatsUserRequest body =
        new AssignSeatsUserRequest()
            .data(
                new AssignSeatsUserRequestData()
                    .type(SeatAssignmentsDataType.SEAT_ASSIGNMENTS)
                    .attributes(
                        new AssignSeatsUserRequestDataAttributes()
                            .productCode("incident_response")
                            .userUuids(Collections.singletonList(USER_DATA_ID))));

    try {
      AssignSeatsUserResponse result = apiInstance.assignSeatsUser(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SeatsApi#assignSeatsUser");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// Assign seats to users returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_seats::SeatsAPI;
use datadog_api_client::datadogV2::model::AssignSeatsUserRequest;
use datadog_api_client::datadogV2::model::AssignSeatsUserRequestData;
use datadog_api_client::datadogV2::model::AssignSeatsUserRequestDataAttributes;
use datadog_api_client::datadogV2::model::SeatAssignmentsDataType;

#[tokio::main]
async fn main() {
    // there is a valid "user" in the system
    let user_data_id = std::env::var("USER_DATA_ID").unwrap();
    let body = AssignSeatsUserRequest::new().data(AssignSeatsUserRequestData::new(
        AssignSeatsUserRequestDataAttributes::new(
            "incident_response".to_string(),
            vec![user_data_id.clone()],
        ),
        SeatAssignmentsDataType::SEAT_ASSIGNMENTS,
    ));
    let configuration = datadog::Configuration::new();
    let api = SeatsAPI::with_config(configuration);
    let resp = api.assign_seats_user(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Assign seats to users returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.SeatsApi(configuration);

// there is a valid "user" in the system
const USER_DATA_ID = process.env.USER_DATA_ID as string;

const params: v2.SeatsApiAssignSeatsUserRequest = {
  body: {
    data: {
      type: "seat-assignments",
      attributes: {
        productCode: "incident_response",
        userUuids: [USER_DATA_ID],
      },
    },
  },
};

apiInstance
  .assignSeatsUser(params)
  .then((data: v2.AssignSeatsUserResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}

## Unassign seats from users{% #unassign-seats-from-users %}

{% tab title="v2" %}

| Datadog site      | API endpoint                                            |
| ----------------- | ------------------------------------------------------- |
| ap1.datadoghq.com | DELETE https://api.ap1.datadoghq.com/api/v2/seats/users |
| ap2.datadoghq.com | DELETE https://api.ap2.datadoghq.com/api/v2/seats/users |
| app.datadoghq.eu  | DELETE https://api.datadoghq.eu/api/v2/seats/users      |
| app.ddog-gov.com  | DELETE https://api.ddog-gov.com/api/v2/seats/users      |
| us2.ddog-gov.com  | DELETE https://api.us2.ddog-gov.com/api/v2/seats/users  |
| app.datadoghq.com | DELETE https://api.datadoghq.com/api/v2/seats/users     |
| us3.datadoghq.com | DELETE https://api.us3.datadoghq.com/api/v2/seats/users |
| us5.datadoghq.com | DELETE https://api.us5.datadoghq.com/api/v2/seats/users |

### Overview

Unassign seats from users for a product code. This endpoint requires any of the following permissions:
`billing_edit``incident_write``on_call_write` 


### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                          | Type     | Description                                                                          |
| ------------ | ------------------------------ | -------- | ------------------------------------------------------------------------------------ |
|              | data                           | object   | The data for the unassign seats user request.                                        |
| data         | attributes [*required*]   | object   | The attributes of the unassign seats user request.                                   |
| attributes   | product_code [*required*] | string   | The product code for which to unassign seats.                                        |
| attributes   | user_uuids [*required*]   | [string] | The list of user IDs to unassign seats from.                                         |
| data         | id                             | string   | The ID of the unassign seats user request.                                           |
| data         | type [*required*]         | enum     | The type of the unassign seats user request. Allowed enum values: `seat-assignments` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "product_code": "",
      "user_uuids": [
        ""
      ]
    },
    "id": "string",
    "type": "seat-assignments"
  }
}
```

{% /tab %}

### Response

{% tab title="204" %}
No Content
{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="422" %}
Unprocessable Entity
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X DELETE "https://api.datadoghq.com/api/v2/seats/users" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "product_code": "",
      "user_uuids": [
        "626a4e8e-64bd-409d-b80e-428f08ac0b62"
      ]
    },
    "type": "seat-assignments"
  }
}
EOF 
                
##### 

```python
"""
Unassign seats from users returns "No Content" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.seats_api import SeatsApi
from datadog_api_client.v2.model.seat_assignments_data_type import SeatAssignmentsDataType
from datadog_api_client.v2.model.unassign_seats_user_request import UnassignSeatsUserRequest
from datadog_api_client.v2.model.unassign_seats_user_request_data import UnassignSeatsUserRequestData
from datadog_api_client.v2.model.unassign_seats_user_request_data_attributes import (
    UnassignSeatsUserRequestDataAttributes,
)

# there is a valid "user" in the system
USER_DATA_ID = environ["USER_DATA_ID"]

body = UnassignSeatsUserRequest(
    data=UnassignSeatsUserRequestData(
        type=SeatAssignmentsDataType.SEAT_ASSIGNMENTS,
        attributes=UnassignSeatsUserRequestDataAttributes(
            product_code="incident_response",
            user_uuids=[
                USER_DATA_ID,
            ],
        ),
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = SeatsApi(api_client)
    api_instance.unassign_seats_user(body=body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Unassign seats from users returns "No Content" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::SeatsAPI.new

# there is a valid "user" in the system
USER_DATA_ID = ENV["USER_DATA_ID"]

body = DatadogAPIClient::V2::UnassignSeatsUserRequest.new({
  data: DatadogAPIClient::V2::UnassignSeatsUserRequestData.new({
    type: DatadogAPIClient::V2::SeatAssignmentsDataType::SEAT_ASSIGNMENTS,
    attributes: DatadogAPIClient::V2::UnassignSeatsUserRequestDataAttributes.new({
      product_code: "incident_response",
      user_uuids: [
        USER_DATA_ID,
      ],
    }),
  }),
})
api_instance.unassign_seats_user(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// Unassign seats from users returns "No Content" response

package main

import (
	"context"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	// there is a valid "user" in the system
	UserDataID := os.Getenv("USER_DATA_ID")

	body := datadogV2.UnassignSeatsUserRequest{
		Data: &datadogV2.UnassignSeatsUserRequestData{
			Type: datadogV2.SEATASSIGNMENTSDATATYPE_SEAT_ASSIGNMENTS,
			Attributes: datadogV2.UnassignSeatsUserRequestDataAttributes{
				ProductCode: "incident_response",
				UserUuids: []string{
					UserDataID,
				},
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewSeatsApi(apiClient)
	r, err := api.UnassignSeatsUser(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `SeatsApi.UnassignSeatsUser`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Unassign seats from users returns "No Content" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.SeatsApi;
import com.datadog.api.client.v2.model.SeatAssignmentsDataType;
import com.datadog.api.client.v2.model.UnassignSeatsUserRequest;
import com.datadog.api.client.v2.model.UnassignSeatsUserRequestData;
import com.datadog.api.client.v2.model.UnassignSeatsUserRequestDataAttributes;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    SeatsApi apiInstance = new SeatsApi(defaultClient);

    // there is a valid "user" in the system
    String USER_DATA_ID = System.getenv("USER_DATA_ID");

    UnassignSeatsUserRequest body =
        new UnassignSeatsUserRequest()
            .data(
                new UnassignSeatsUserRequestData()
                    .type(SeatAssignmentsDataType.SEAT_ASSIGNMENTS)
                    .attributes(
                        new UnassignSeatsUserRequestDataAttributes()
                            .productCode("incident_response")
                            .userUuids(Collections.singletonList(USER_DATA_ID))));

    try {
      apiInstance.unassignSeatsUser(body);
    } catch (ApiException e) {
      System.err.println("Exception when calling SeatsApi#unassignSeatsUser");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// Unassign seats from users returns "No Content" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_seats::SeatsAPI;
use datadog_api_client::datadogV2::model::SeatAssignmentsDataType;
use datadog_api_client::datadogV2::model::UnassignSeatsUserRequest;
use datadog_api_client::datadogV2::model::UnassignSeatsUserRequestData;
use datadog_api_client::datadogV2::model::UnassignSeatsUserRequestDataAttributes;

#[tokio::main]
async fn main() {
    // there is a valid "user" in the system
    let user_data_id = std::env::var("USER_DATA_ID").unwrap();
    let body = UnassignSeatsUserRequest::new().data(UnassignSeatsUserRequestData::new(
        UnassignSeatsUserRequestDataAttributes::new(
            "incident_response".to_string(),
            vec![user_data_id.clone()],
        ),
        SeatAssignmentsDataType::SEAT_ASSIGNMENTS,
    ));
    let configuration = datadog::Configuration::new();
    let api = SeatsAPI::with_config(configuration);
    let resp = api.unassign_seats_user(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Unassign seats from users returns "No Content" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.SeatsApi(configuration);

// there is a valid "user" in the system
const USER_DATA_ID = process.env.USER_DATA_ID as string;

const params: v2.SeatsApiUnassignSeatsUserRequest = {
  body: {
    data: {
      type: "seat-assignments",
      attributes: {
        productCode: "incident_response",
        userUuids: [USER_DATA_ID],
      },
    },
  },
};

apiInstance
  .unassignSeatsUser(params)
  .then((data: any) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
